Loading...
Searching...
No Matches
itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage > Class Template Reference
Components » Metrics

`#include <itkNormalizedGradientCorrelationImageToImageMetric.h>`

## Detailed Description

template<class TFixedImage, class TMovingImage>
class itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >

An metric based on the itk::NormalizedGradientCorrelationImageToImageMetric.

Definition at line 44 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

Inheritance diagram for itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >:
[legend]

## Public Types

using | CastFixedImageFilterPointer = typename CastFixedImageFilterType::Pointer
using | CastFixedImageFilterType = itk::CastImageFilter<FixedImageType, FixedGradientImageType>
using | CastMovedImageFilterPointer = typename CastMovedImageFilterType::Pointer
using | CastMovedImageFilterType = itk::CastImageFilter<TransformedMovingImageType, MovedGradientImageType>
using | CombinationTransformPointer = typename CombinationTransformType::Pointer
using | CombinationTransformType = typename itk::AdvancedCombinationTransform<ScalarType, FixedImageDimension>
using | ConstPointer = SmartPointer<const Self>
using | FixedGradientImageType = itk::Image<RealType, Self::FixedImageDimension>
using | FixedGradientPixelType = typename FixedGradientImageType::PixelType
using | FixedImagePixelType = typename TFixedImage::PixelType
using | InterpolatorPointer = typename InterpolatorType::Pointer
using | MaskImageType = itk::Image<unsigned char, Self::FixedImageDimension>
using | MaskImageTypePointer = typename MaskImageType::Pointer
using | MovedGradientImageType = itk::Image<RealType, Self::MovedImageDimension>
using | MovedGradientPixelType = typename MovedGradientImageType::PixelType
using | MovedImagePixelType = typename TMovingImage::PixelType
using | MovingImagePointer
using | MovingImageRegionType
using | Pointer = SmartPointer<Self>
using | RayCastInterpolatorPointer = typename RayCastInterpolatorType::Pointer
using | RayCastInterpolatorType = typename itk::AdvancedRayCastInterpolateImageFunction<MovingImageType, ScalarType>
using | ScalarType = typename TransformType::ScalarType
using | ScalesType = typename Optimizer::ScalesType
using | Self = NormalizedGradientCorrelationImageToImageMetric
using | Superclass = AdvancedImageToImageMetric<TFixedImage, TMovingImage>
using | TransformConstPointer = typename TransformType::ConstPointer
using | TransformedMovingImageType = itk::Image<FixedImagePixelType, Self::FixedImageDimension>
using | TransformMovingImageFilterPointer = typename TransformMovingImageFilterType::Pointer
using | TransformMovingImageFilterType = itk::ResampleImageFilter<MovingImageType, TransformedMovingImageType>
Public Types inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
using | AdvancedTransformType = AdvancedTransform<ScalarType, FixedImageDimension, MovingImageDimension>
using | BSplineOrder1TransformPointer = typename BSplineOrder1TransformType::Pointer
using | BSplineOrder1TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 1>
using | BSplineOrder2TransformPointer = typename BSplineOrder2TransformType::Pointer
using | BSplineOrder2TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 2>
using | BSplineOrder3TransformPointer = typename BSplineOrder3TransformType::Pointer
using | BSplineOrder3TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 3>
using | CombinationTransformType = AdvancedCombinationTransform<ScalarType, FixedImageDimension>
using | ConstPointer = SmartPointer<const Self>
using | DerivativeValueType = typename DerivativeType::ValueType
using | FixedImageLimiterOutputType = typename FixedImageLimiterType::OutputType
using | FixedImageLimiterPointer = typename FixedImageLimiterType::Pointer
using | FixedImageLimiterType = LimiterFunctionBase<RealType, FixedImageDimension>
using | FixedImageMaskConstPointer = SmartPointer<const FixedImageMaskType>
using | FixedImageMaskPointer = SmartPointer<FixedImageMaskType>
using | FixedImageMaskType = ImageMaskSpatialObject<Self::FixedImageDimension>
using | FixedImagePixelType = typename FixedImageType::PixelType
using | FixedImagePointer = typename FixedImageType::Pointer
using | ImageSampleContainerPointer = typename ImageSamplerType::OutputVectorContainerPointer
using | ImageSampleContainerType = typename ImageSamplerType::OutputVectorContainerType
using | ImageSamplerPointer = typename ImageSamplerType::Pointer
using | ImageSamplerType = ImageSamplerBase<FixedImageType>
using | MovingImageDerivativeScalesType = FixedArray<double, Self::MovingImageDimension>
using | MovingImageLimiterOutputType = typename MovingImageLimiterType::OutputType
using | MovingImageLimiterPointer = typename MovingImageLimiterType::Pointer
using | MovingImageLimiterType = LimiterFunctionBase<RealType, MovingImageDimension>
using | MovingImageMaskConstPointer = SmartPointer<const MovingImageMaskType>
using | MovingImageMaskPointer = SmartPointer<MovingImageMaskType>
using | MovingImageMaskType = ImageMaskSpatialObject<Self::MovingImageDimension>
using | MovingImagePointer = typename MovingImageType::Pointer
using | MovingImageRegionType = typename MovingImageType::RegionType
using | NumberOfParametersType = typename AdvancedTransformType::NumberOfParametersType
using | Pointer = SmartPointer<Self>
using | ScalarType = typename TransformType::ScalarType
using | Self = AdvancedImageToImageMetric
using | Superclass = ImageToImageMetric<TFixedImage, TMovingImage>
using | ThreadInfoType = MultiThreaderBase::WorkUnitInfo

## Public Member Functions

virtual const char * | GetClassName () const
void | GetDerivative (const TransformParametersType &parameters, DerivativeType &derivative) const override
virtual const double & | GetDerivativeDelta ()
virtual const ScalesType & | GetScales ()
MeasureType | GetValue (const TransformParametersType &parameters) const override
void | GetValueAndDerivative (const TransformParametersType &parameters, MeasureType &Value, DerivativeType &derivative) const override
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (NormalizedGradientCorrelationImageToImageMetric)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
| itkStaticConstMacro (MovedImageDimension, unsigned int, MovingImageType::ImageDimension)
virtual void | SetDerivativeDelta (double _arg)
virtual void | SetScales (ScalesType _arg)
void | SetTransformParameters (const TransformParametersType &parameters) const
void | WriteGradientImagesToFiles () const
Public Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
virtual void | BeforeThreadedGetValueAndDerivative (const TransformParametersType &parameters) const
virtual const FixedImageLimiterType * | GetFixedImageLimiter ()
const FixedImageMaskType * | GetFixedImageMask () const override
virtual double | GetFixedLimitRangeRatio () const
ImageSamplerType * | GetImageSampler () const
virtual const MovingImageDerivativeScalesType & | GetMovingImageDerivativeScales ()
virtual const MovingImageLimiterType * | GetMovingImageLimiter ()
const MovingImageMaskType * | GetMovingImageMask () const override
virtual double | GetMovingLimitRangeRatio () const
virtual double | GetRequiredRatioOfValidSamples () const
virtual bool | GetScaleGradientWithRespectToMovingImageOrientation () const
const AdvancedTransformType * | GetTransform () const override
AdvancedTransformType * | GetTransform () override
virtual bool | GetUseFixedImageLimiter () const
virtual bool | GetUseImageSampler () const
virtual const bool & | GetUseMetricSingleThreaded ()
virtual bool | GetUseMovingImageDerivativeScales () const
virtual bool | GetUseMovingImageLimiter () const
virtual const bool & | GetUseMultiThread ()
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedImageToImageMetric)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, TMovingImage::ImageDimension)
virtual void | SetFixedImageLimiter (FixedImageLimiterType *_arg)
virtual void | SetFixedImageMask (const FixedImageMaskType *const arg)
virtual void | SetFixedLimitRangeRatio (double _arg)
virtual void | SetImageSampler (ImageSamplerType *_arg)
virtual void | SetMovingImageDerivativeScales (MovingImageDerivativeScalesType _arg)
virtual void | SetMovingImageLimiter (MovingImageLimiterType *_arg)
virtual void | SetMovingImageMask (const MovingImageMaskType *const arg)
virtual void | SetMovingLimitRangeRatio (double _arg)
virtual void | SetRequiredRatioOfValidSamples (double _arg)
virtual void | SetScaleGradientWithRespectToMovingImageOrientation (bool _arg)
virtual void | SetTransform (AdvancedTransformType *arg)
virtual void | SetUseMetricSingleThreaded (bool _arg)
virtual void | SetUseMovingImageDerivativeScales (bool _arg)
virtual void | SetUseMultiThread (bool _arg)
virtual void | UseMetricSingleThreadedOff ()
virtual void | UseMetricSingleThreadedOn ()
virtual void | UseMultiThreadOff ()
virtual void | UseMultiThreadOn ()

## Static Public Member Functions

static Pointer | New ()

## Protected Types

using | FixedSobelFilter = NeighborhoodOperatorImageFilter<FixedGradientImageType, FixedGradientImageType>
using | MovedSobelFilter = NeighborhoodOperatorImageFilter<MovedGradientImageType, MovedGradientImageType>
Protected Types inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
using | BSplineInterpolatorFloatPointer = typename BSplineInterpolatorFloatType::Pointer
using | BSplineInterpolatorFloatType
using | BSplineInterpolatorPointer = typename BSplineInterpolatorType::Pointer
using | BSplineInterpolatorType
using | FixedImageIndexType = typename FixedImageType::IndexType
using | FixedImageIndexValueType = typename FixedImageIndexType::IndexValueType
using | FixedImagePointType = typename TransformType::InputPointType
using | LinearInterpolatorPointer = typename LinearInterpolatorType::Pointer
using | LinearInterpolatorType = AdvancedLinearInterpolateImageFunction<MovingImageType, CoordinateRepresentationType>
using | MovingImageContinuousIndexType = typename InterpolatorType::ContinuousIndexType
using | MovingImageDerivativeType = typename BSplineInterpolatorType::CovariantVectorType
using | MovingImageIndexType = typename MovingImageType::IndexType
using | MovingImagePointType = typename TransformType::OutputPointType
using | NonZeroJacobianIndicesType = typename AdvancedTransformType::NonZeroJacobianIndicesType
using | ReducedBSplineInterpolatorPointer = typename ReducedBSplineInterpolatorType::Pointer
using | ReducedBSplineInterpolatorType

## Protected Member Functions

void | ComputeMeanFixedGradient () const
void | ComputeMeanMovedGradient () const
MeasureType | ComputeMeasure (const TransformParametersType &parameters) const
| NormalizedGradientCorrelationImageToImageMetric ()=default
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~NormalizedGradientCorrelationImageToImageMetric () override=default
Protected Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
| AdvancedImageToImageMetric ()
virtual void | AfterThreadedGetValue (MeasureType &) const
virtual void | AfterThreadedGetValueAndDerivative (MeasureType &, DerivativeType &) const
void | CheckForAdvancedTransform ()
void | CheckForBSplineInterpolator ()
void | CheckForBSplineTransform () const
void | CheckNumberOfSamples (unsigned long wanted, unsigned long found) const
virtual bool | EvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient) const
bool | EvaluateTransformJacobian (const FixedImagePointType &fixedImagePoint, TransformJacobianType &jacobian, NonZeroJacobianIndicesType &nzji) const
virtual void | EvaluateTransformJacobianInnerProduct (const TransformJacobianType &jacobian, const MovingImageDerivativeType &movingImageDerivative, DerivativeType &imageJacobian) const
bool | FastEvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient, const ThreadIdType threadId) const
virtual void | InitializeImageSampler ()
void | InitializeLimiters ()
virtual void | InitializeThreadingParameters () const
virtual bool | IsInsideMovingMask (const MovingImagePointType &point) const
| itkAlignedTypedef (ITK_CACHE_LINE_ALIGNMENT, PaddedGetValueAndDerivativePerThreadStruct, AlignedGetValueAndDerivativePerThreadStruct)
| itkPadStruct (ITK_CACHE_LINE_ALIGNMENT, GetValueAndDerivativePerThreadStruct, PaddedGetValueAndDerivativePerThreadStruct)
void | LaunchGetValueAndDerivativeThreaderCallback () const
void | LaunchGetValueThreaderCallback () const
void | PrintSelf (std::ostream &os, Indent indent) const override
void | SetFixedImageMask (const typename Superclass::FixedImageMaskType *) final
void | SetFixedImageMask (typename Superclass::FixedImageMaskType *) final
void | SetMovingImageMask (const typename Superclass::MovingImageMaskType *) final
void | SetMovingImageMask (typename Superclass::MovingImageMaskType *) final
virtual void | SetUseFixedImageLimiter (bool _arg)
virtual void | SetUseImageSampler (bool _arg)
virtual void | SetUseMovingImageLimiter (bool _arg)
virtual void | ThreadedGetValue (ThreadIdType) const
virtual void | ThreadedGetValueAndDerivative (ThreadIdType) const
MovingImagePointType | TransformPoint (const FixedImagePointType &fixedImagePoint) const
| ~AdvancedImageToImageMetric () override=default

## Private Attributes

CastFixedImageFilterPointer | m_CastFixedImageFilter { CastFixedImageFilterType::New() }
CastMovedImageFilterPointer | m_CastMovedImageFilter { CastMovedImageFilterType::New() }
CombinationTransformPointer | m_CombinationTransform { CombinationTransformType::New() }
double | m_DerivativeDelta { 0.001 }
ZeroFluxNeumannBoundaryCondition< FixedGradientImageType > | m_FixedBoundCond {}
FixedSobelFilter::Pointer | m_FixedSobelFilters [Self::FixedImageDimension] {}
SobelOperator< FixedGradientPixelType, Self::FixedImageDimension > | m_FixedSobelOperators [FixedImageDimension] {}
FixedGradientPixelType | m_MeanFixedGradient [FixedImageDimension] {}
MovedGradientPixelType | m_MeanMovedGradient [MovedImageDimension] {}
ZeroFluxNeumannBoundaryCondition< MovedGradientImageType > | m_MovedBoundCond {}
MovedSobelFilter::Pointer | m_MovedSobelFilters [Self::MovedImageDimension] {}
SobelOperator< MovedGradientPixelType, Self::MovedImageDimension > | m_MovedSobelOperators [MovedImageDimension] {}
ScalesType | m_Scales {}
TransformMovingImageFilterPointer | m_TransformMovingImageFilter { TransformMovingImageFilterType::New() }

## Additional Inherited Members

Static Protected Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | AccumulateDerivativesThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueAndDerivativeThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueThreaderCallback (void *arg)
Protected Attributes inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
AdvancedTransformType::Pointer | m_AdvancedTransform { nullptr }
FixedImageLimiterOutputType | m_FixedImageMaxLimit { 1 }
FixedImageLimiterOutputType | m_FixedImageMinLimit { 0 }
FixedImagePixelType | m_FixedImageTrueMax { 1 }
FixedImagePixelType | m_FixedImageTrueMin { 0 }
double | m_FixedLimitRangeRatio { 0.01 }
std::unique_ptr< AlignedGetValueAndDerivativePerThreadStruct[]> | m_GetValueAndDerivativePerThreadVariables
ThreadIdType | m_GetValueAndDerivativePerThreadVariablesSize { 0 }
ImageSamplerPointer | m_ImageSampler { nullptr }
MovingImageLimiterOutputType | m_MovingImageMaxLimit { 1 }
MovingImageLimiterOutputType | m_MovingImageMinLimit { 0 }
MovingImagePixelType | m_MovingImageTrueMax { 1 }
MovingImagePixelType | m_MovingImageTrueMin { 0 }
double | m_MovingLimitRangeRatio { 0.01 }
MultiThreaderParameterType | m_ThreaderMetricParameters {}
bool | m_TransformIsBSpline { false }
bool | m_UseMetricSingleThreaded { true }
bool | m_UseMultiThread { false }

## Member Typedef Documentation

## CastFixedImageFilterPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::CastFixedImageFilterPointer = typename CastFixedImageFilterType::Pointer

Definition at line 107 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## CastFixedImageFilterType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::CastFixedImageFilterType = itk::CastImageFilter<FixedImageType, FixedGradientImageType>

Definition at line 106 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## CastMovedImageFilterPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::CastMovedImageFilterPointer = typename CastMovedImageFilterType::Pointer

Definition at line 114 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## CastMovedImageFilterType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::CastMovedImageFilterType = itk::CastImageFilter<TransformedMovingImageType, MovedGradientImageType>

Definition at line 113 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## CombinationTransformPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::CombinationTransformPointer = typename CombinationTransformType::Pointer

Definition at line 95 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## CombinationTransformType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::CombinationTransformType = typename itk::AdvancedCombinationTransform<ScalarType, FixedImageDimension>

Types for transforming the moving image

Definition at line 94 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## ConstPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ConstPointer = SmartPointer<const Self>

Definition at line 54 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## FixedGradientImageType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::FixedGradientImageType = itk::Image<RealType, Self::FixedImageDimension>

Sobel filters to compute the gradients of the Fixed Image

Definition at line 105 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## FixedGradientPixelType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::FixedGradientPixelType = typename FixedGradientImageType::PixelType

Definition at line 108 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## FixedImagePixelType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::FixedImagePixelType = typename TFixedImage::PixelType

Definition at line 87 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## FixedSobelFilter

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::FixedSobelFilter = NeighborhoodOperatorImageFilter<FixedGradientImageType, FixedGradientImageType>

protected

Definition at line 172 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## InterpolatorPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::InterpolatorPointer = typename InterpolatorType::Pointer

Definition at line 77 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MaskImageType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::MaskImageType = itk::Image<unsigned char, Self::FixedImageDimension>

Definition at line 97 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MaskImageTypePointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::MaskImageTypePointer = typename MaskImageType::Pointer

Definition at line 98 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MovedGradientImageType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::MovedGradientImageType = itk::Image<RealType, Self::MovedImageDimension>

Definition at line 112 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MovedGradientPixelType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::MovedGradientPixelType = typename MovedGradientImageType::PixelType

Definition at line 115 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MovedImagePixelType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::MovedImagePixelType = typename TMovingImage::PixelType

Definition at line 88 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MovedSobelFilter

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::MovedSobelFilter = NeighborhoodOperatorImageFilter<MovedGradientImageType, MovedGradientImageType>

protected

Definition at line 173 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## MovingImagePointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImagePointer

Definition at line 104 of file itkAdvancedImageToImageMetric.h.

## MovingImageRegionType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageRegionType

Definition at line 138 of file itkAdvancedImageToImageMetric.h.

## Pointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::Pointer = SmartPointer<Self>

Definition at line 53 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## RayCastInterpolatorPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::RayCastInterpolatorPointer = typename RayCastInterpolatorType::Pointer

Definition at line 102 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## RayCastInterpolatorType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::RayCastInterpolatorType = typename itk::AdvancedRayCastInterpolateImageFunction<MovingImageType, ScalarType>

Definition at line 101 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## ScalarType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ScalarType = typename TransformType::ScalarType

Definition at line 71 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## ScalesType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ScalesType = typename Optimizer::ScalesType

Definition at line 89 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## Self

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::Self = NormalizedGradientCorrelationImageToImageMetric

Standard class typedefs.

Definition at line 51 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## Superclass

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::Superclass = AdvancedImageToImageMetric<TFixedImage, TMovingImage>

Definition at line 52 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## TransformConstPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::TransformConstPointer = typename TransformType::ConstPointer

Definition at line 73 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## TransformedMovingImageType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::TransformedMovingImageType = itk::Image<FixedImagePixelType, Self::FixedImageDimension>

Definition at line 96 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## TransformMovingImageFilterPointer

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::TransformMovingImageFilterPointer = typename TransformMovingImageFilterType::Pointer

Definition at line 100 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## TransformMovingImageFilterType

template<class TFixedImage, class TMovingImage>

using itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::TransformMovingImageFilterType = itk::ResampleImageFilter<MovingImageType, TransformedMovingImageType>

Definition at line 99 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## Constructor & Destructor Documentation

## NormalizedGradientCorrelationImageToImageMetric()

template<class TFixedImage, class TMovingImage>

itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::NormalizedGradientCorrelationImageToImageMetric | ( |  | ) |

protected default

## ~NormalizedGradientCorrelationImageToImageMetric()

template<class TFixedImage, class TMovingImage>

itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::~NormalizedGradientCorrelationImageToImageMetric | ( |  | ) |

override protected default

## Member Function Documentation

## ComputeMeanFixedGradient()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ComputeMeanFixedGradient | ( |  | ) | const

protected

## ComputeMeanMovedGradient()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ComputeMeanMovedGradient | ( |  | ) | const

protected

Compute the mean of the fixed and moved image gradients.

## ComputeMeasure()

template<class TFixedImage, class TMovingImage>

MeasureType itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ComputeMeasure | ( | const TransformParametersType & | parameters | ) | const

protected

Compute the similarity measure

## GetClassName()

template<class TFixedImage, class TMovingImage>

virtual const char * itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >.

Reimplemented in elastix::NormalizedGradientCorrelationMetric< TElastix >.

## GetDerivative()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::GetDerivative | ( | const TransformParametersType & | parameters,
|  | DerivativeType & | derivative ) const

override

Get the derivatives of the match measure.

## GetDerivativeDelta()

template<class TFixedImage, class TMovingImage>

virtual const double & itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::GetDerivativeDelta | ( |  | ) |

virtual

## GetScales()

template<class TFixedImage, class TMovingImage>

virtual const ScalesType & itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::GetScales | ( |  | ) |

virtual

## GetValue()

template<class TFixedImage, class TMovingImage>

MeasureType itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::GetValue | ( | const TransformParametersType & | parameters | ) | const

override

Get the value for single valued optimizers.

## GetValueAndDerivative()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::GetValueAndDerivative | ( | const TransformParametersType & | parameters,
|  | MeasureType & | Value,
|  | DerivativeType & | derivative ) const

override

Get value and derivatives for multiple valued optimizers.

## Initialize()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::Initialize | ( |  | ) |

override

Initialize the Metric by making sure that all the components are present and plugged together correctly.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedImage, class TMovingImage>

itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TFixedImage, class TMovingImage>

itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | TFixedImage::ImageDimension | )

## itkStaticConstMacro() [2/2]

template<class TFixedImage, class TMovingImage>

itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | MovedImageDimension | ,
|  | unsigned int | ,
|  | MovingImageType::ImageDimension | )

Sobel filters to compute the gradients of the Moved Image

## New()

template<class TFixedImage, class TMovingImage>

Pointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

## SetDerivativeDelta()

template<class TFixedImage, class TMovingImage>

virtual void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::SetDerivativeDelta | ( | double | _arg | ) |

virtual

Set/Get the value of Delta used for computing derivatives by finite differences in the GetDerivative() method.

## SetScales()

template<class TFixedImage, class TMovingImage>

virtual void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::SetScales | ( | ScalesType | _arg | ) |

virtual

Set/Get Scales

## SetTransformParameters()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::SetTransformParameters | ( | const TransformParametersType & | parameters | ) | const

Set the parameters defining the Transform.

## WriteGradientImagesToFiles()

template<class TFixedImage, class TMovingImage>

void itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::WriteGradientImagesToFiles | ( |  | ) | const

Write gradient images to a files for debugging purposes.

## Field Documentation

## m_CastFixedImageFilter

template<class TFixedImage, class TMovingImage>

CastFixedImageFilterPointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_CastFixedImageFilter { CastFixedImageFilterType::New() }

private

The Sobel gradients of the fixed image

Definition at line 190 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_CastMovedImageFilter

template<class TFixedImage, class TMovingImage>

CastMovedImageFilterPointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_CastMovedImageFilter { CastMovedImageFilterType::New() }

private

The Sobel gradients of the moving image

Definition at line 200 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_CombinationTransform

template<class TFixedImage, class TMovingImage>

CombinationTransformPointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_CombinationTransform { CombinationTransformType::New() }

private

Definition at line 178 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_DerivativeDelta

template<class TFixedImage, class TMovingImage>

double itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_DerivativeDelta { 0.001 }

private

Definition at line 177 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_FixedBoundCond

template<class TFixedImage, class TMovingImage>

ZeroFluxNeumannBoundaryCondition<FixedGradientImageType> itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_FixedBoundCond {}

private

Definition at line 197 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_FixedSobelFilters

template<class TFixedImage, class TMovingImage>

FixedSobelFilter::Pointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_FixedSobelFilters[Self::FixedImageDimension] {}

private

Definition at line 194 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_FixedSobelOperators

template<class TFixedImage, class TMovingImage>

SobelOperator<FixedGradientPixelType, Self::FixedImageDimension> itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_FixedSobelOperators[FixedImageDimension] {}

private

Definition at line 192 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_MeanFixedGradient

template<class TFixedImage, class TMovingImage>

FixedGradientPixelType itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_MeanFixedGradient[FixedImageDimension] {}

mutable private

The mean of the fixed image gradients.

Definition at line 184 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_MeanMovedGradient

template<class TFixedImage, class TMovingImage>

MovedGradientPixelType itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_MeanMovedGradient[MovedImageDimension] {}

mutable private

The mean of the moving image gradients.

Definition at line 181 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_MovedBoundCond

template<class TFixedImage, class TMovingImage>

ZeroFluxNeumannBoundaryCondition<MovedGradientImageType> itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_MovedBoundCond {}

private

Definition at line 196 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_MovedSobelFilters

template<class TFixedImage, class TMovingImage>

MovedSobelFilter::Pointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_MovedSobelFilters[Self::MovedImageDimension] {}

private

Definition at line 203 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_MovedSobelOperators

template<class TFixedImage, class TMovingImage>

SobelOperator<MovedGradientPixelType, Self::MovedImageDimension> itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_MovedSobelOperators[MovedImageDimension] {}

private

Definition at line 201 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_Scales

template<class TFixedImage, class TMovingImage>

ScalesType itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_Scales {}

private

Definition at line 176 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

## m_TransformMovingImageFilter

template<class TFixedImage, class TMovingImage>

TransformMovingImageFilterPointer itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >::m_TransformMovingImageFilter { TransformMovingImageFilterType::New() }

private

The filter for transforming the moving images.

Definition at line 187 of file itkNormalizedGradientCorrelationImageToImageMetric.h.

Generated on 1768596610 for elastix by 1.15.0 |